/*
Fondamenti di Informatica e Laboratorio
Ingegneria Telematica
Terza prova in itinere del 29/01/2008

Tempo a disposizione: 2h 30 min

Scrivere un programma per la gestione dei soci di un club e delle prenotazioni delle attivit presso il club.
I soci sono caratterizzati dalle seguenti informazioni: Nome, Cognome, numero tessera, data di nascita, tipo di iscrizione  (0=ragazzi, 1=giovani, 2=adulti, 3=anziani).
I soci sono inseriti in un vettore di 4 liste, una  per ogni tipo di iscrizione.
Per quanto riguarda le prenotazioni, esse sono caratterizzate dalle seguenti informazioni: numero di tessera, tipo di iscrizione, codice attivit, giorno della settimana (0=lun, 1=mar, .., 5= sab).
Ogni nuova prenotazione viene inserita in una tabella allocata dinamicamente con 6 righe, una per ogni giorno lavorativo della settimana.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento in lista di un nuovo socio;
2.Eliminazione di un socio dopo averne visualizzato il nome, il cognome e la data di iscrizione;
3.Inserimento ordinato rispetto al numero di tessera di una prenotazione nella tabella;
4.Visualizzazione delle prenotazioni relative a un certo giorno.

Liberare la memoria allocata dinamicamente.

*/
#include <stdio.h>
#include <stdlib.h>

typedef struct{
	char nome[20], cognome[20], data[11];
	int tipo, numero;
}socio;

struct atomo{
	socio dato;
	struct atomo *next;
};

typedef struct{
	int numero, tipo, codice, giorno;
}prenotazione;

void leggi_socio(socio *s);
void ins_socio(struct atomo **TS, socio s);
void elimina(struct atomo **TS, int n);
void leggi_prenotazione(prenotazione *p);
void inserisci_tab(prenotazione **RP, int *N, prenotazione p);
void visualizza(prenotazione *RP, int N);
void menu();

main(){
	socio  s;
	struct atomo *T[4], *aux;
	int op, tipo, giorno, numero, N[6];
	prenotazione *P[6], pr;

	for(tipo=0; tipo<4; tipo++)
		T[tipo]=NULL;
	for(tipo=0; tipo<6; tipo++){
		P[tipo]=NULL;
		N[tipo]=0;
	}

	do{
		menu();
		scanf("%d", &op);
		switch(op){
			case 1:
				leggi_socio(&s);
				ins_socio(&T[s.tipo], s);
				break;

			case 2:
				printf("\nInserisci il tipo di iscrizione del socio da eliminare: ");
				scanf("%d", &tipo);
				printf("\nInserisci il numero di tessera del socio da eliminare: ");
				scanf("%d", &numero);
				elimina(&T[tipo], numero);
				break;

			case 3:
				leggi_prenotazione(&pr);
				inserisci_tab(&P[pr.giorno], &N[pr.giorno], pr);
				break;

			case 4:
				printf("\nInserisci il giorno: ");
				scanf("%d", &giorno);
				visualizza(P[giorno], N[giorno]);
				break;

			default:;
		}
	}while(op!=0);

	for(tipo=0; tipo<6; tipo++)
		free(P[tipo]);
	for(tipo=0; tipo<4; tipo++)
		while(T[tipo]!=NULL)
			{
			 aux=T[tipo];
			 T[tipo]=aux->next;
			 free(aux);
		 	}
	}


void menu(){
	printf("\n1- Inserimento di un socio");
	printf("\n2- Eliminazione di un socio");
	printf("\n3- Inserimento prenotazione");
	printf("\n4- Visualizza prenotazioni");
	printf("\n0- fine");

	printf("\n\nQuale operazione vuoi eseguire? ");
}

void leggi_socio(socio *s){
	printf("\nNome: ");
	scanf("%s", s->nome);
	printf("\nCognome: ");
	scanf("%s", s->cognome);
	printf("\nData di nascita: ");
	scanf("%s", s->data);
	printf("\nTipo di iscrizione (0,1,2,3): ");
	scanf("%d", &s->tipo);
	printf("\nNumero di tessera: ");
	scanf("%d", &s->numero);
}

void ins_socio(struct atomo **TS, socio s){
	struct atomo *aux;

	aux=malloc(sizeof(struct atomo));
	if(aux==NULL)
		{
	   	printf("\nElemento non inserito!");
	   	return;
		}
	aux->dato=s;
	aux->next=*TS;
	*TS=aux;
}

void elimina(struct atomo **TS, int n){
	struct atomo *aux,*l1,*l2;

	if(*TS==NULL)
		{
			printf("Lista vuota");
			return;
		}
	if((*TS)->dato.numero==n) /* In testa*/
		{
			aux=*TS;
			printf("\nNome: %s", aux->dato.nome);
			printf("\nCognome: %s", aux->dato.cognome);
			printf("\nData di iscrizione: %s", aux->dato.data);

			*TS=aux->next;
			free(aux);
			return;
		}
	/* In posizione successiva*/
	l2=*TS;
	l1=l2->next;
	while(l1!=NULL)
		if(l1->dato.numero==n)
		{
			l2->next=l1->next;
		  	printf("\nNome: %s", l1->dato.nome);
			printf("\nCognome: %s", l1->dato.cognome);
			printf("\nData di iscrizione: %s", l1->dato.data);
			free(l1);
			return;
		}
		else
		{
			l1=l1->next;
			l2=l2->next;
		}
   printf("Elemento non presente\n");
}

void leggi_prenotazione(prenotazione *p){
	printf("\nNumero di tessera: ");
	scanf("%d", &p->numero);
	printf("\nTipo di iscrizione (0, 1, 2, 3): ");
	scanf("%d", &p->tipo);
	printf("\nCodice attivita': ");
	scanf("%d", &p->codice);
	printf("\nGiorno della settimana (0, 1, .. , 5): ");
	scanf("%d", &p->giorno);
}

void inserisci_tab(prenotazione **RP, int *N, prenotazione p)
{
	prenotazione *a;

	a=realloc(*RP, sizeof(prenotazione)*(*N+1));
	if(a==NULL){
		printf("\nImpossibile inserire!");
		return;
	}
	*RP=a;
	(*RP)[*N]=p;
	(*N)++;

}

void visualizza(prenotazione *RP, int N){
	int i;
	for(i=0; i<N; i++){
		printf("\nNumero: %d", RP[i].numero);
		printf("\nTipo: %d", RP[i].tipo);
		printf("\nCodice: %d", RP[i].codice);
		printf("\nGiorno: %d", RP[i].giorno);
	}
}

